const DEBUG_MODE = 1;

window.addEventListener('load', function() { gBrowser.addEventListener('load', pdOnLoad, true); }, false);
window.addEventListener('submit', pdOnSubmit, true);
addEventListener('unload', pdOnUnload, false);


var pdXPCOM = null;
var tmpSignons = true;
var autoFillTimerID = 0;
var autoFillDocument = null;


var isFirefox3__ = - 1;
function isFirefox3()
{
   if (isFirefox3__ == - 1)
   {
      if ('@mozilla.org/login-manager;1' in Components.classes)
        isFirefox3__ = 1;
      else
        isFirefox3__ = 0;
   }
   return (isFirefox3__ == 1);
}


function initXPCOM()
{
   try
   {
      var compClass = Components.classes[ "@acebit.com/PasswordDepotXPCOM;1" ];
      var instance = compClass.createInstance();
      pdXPCOM = instance.QueryInterface(Components.interfaces.IPasswordDepotXPCOM);
   }
   catch (e)
   {
     if (DEBUG_MODE) 
        window.alert("initXPCOM " + e);
      pdXPCOM = null;
   }

   try
   {
      if ('@mozilla.org/preferences;1' in Components.classes)
      {
         if (('nsIPrefService' in Components.interfaces) && ('nsIPrefBranch' in Components.interfaces))
         {
            var PrefService = Components.classes['@mozilla.org/preferences;1'].createInstance(Components.interfaces.nsIPref);
            var PrefBranch = PrefService.getBranch('signon.');
            if (PrefBranch != null)
            {
               tmpSignons = PrefBranch.getBoolPref('rememberSignons');
               if (isFirefox3())
               {
                  PrefBranch.setBoolPref('rememberSignons', false);
               }
               else
               {
                  PrefBranch.setBoolPref('rememberSignons', true);
               }
            }
         }
         else if ('nsIPref' in Components.interfaces)
         {
            var Pref = Components.classes['@mozilla.org/preferences;1'].createInstance(Components.interfaces.nsIPref);
            tmpSignons = Pref.GetBoolPref('signon.rememberSignons');
            if (isFirefox3())
            {
               Pref.SetBoolPref('signon.rememberSignons', false);
            }
            else
            {
               Pref.SetBoolPref('signon.rememberSignons', true);
            }
         }
      }
   }
   catch (e)
   {
     if (DEBUG_MODE) 
       window.alert("initXPCOM 2 " + e);
   }
}

initXPCOM();

function GetDocumentUrl(ADocument)
{
   var rslt = '';
   if (ADocument)
   {
      try
      {
         if (ADocument.location)
           rslt = ADocument.location.href;
         else
           rslt = ADocument.URL;
      }
      catch (e)
      {
         rslt = ADocument.URL;
      }
   }
   return rslt;
}

function ContainsText(AText, ASubText)
{
   try
   {
      var SubText = ASubText.toLowerCase();
      var Text = AText.toLowerCase();
      if (Text.indexOf(SubText) >= 0)
      {
         return true;
      }
      return false;
   }
   catch (e)
   {
      return false;
   }
}

function isValidDocument(ADocument)
{
   try
   {
      if ((pdXPCOM == null) || (ADocument == null))
      {
         return false;
      }
      var sURL = GetDocumentUrl(ADocument);

      if ((ADocument.nodeName != '#document') ||  ContainsText(ADocument.contentType, 'xml') || ContainsText(sURL, 'about:'))
      {
         return false;
      }
      return true;
   }
   catch (e)
   {
      return false;
   }
}

function pdAutoFillDocument()
{
   
   if ( autoFillTimerID )
   {
     clearTimeout(autoFillTimerID);
     autoFillTimerID = 0;
   }
  
   if (pdXPCOM)
   try
   {
      try
      {
         netscape.security.PrivilegeManager.enablePrivilege('UniversalBrowserRead');
      }
      catch (ErrorMessage)
      {
      }
      if (autoFillDocument)
      {
        pdXPCOM.OnLoadWebForm(autoFillDocument);   
        autoFillDocument = null;
      }
      return true;           
   }
   catch (e)
   {
      return false;
   }
}

function pdOnSubmit(AEvent)
{
   if (AEvent)
   try
   {     
      var nsForm = AEvent.originalTarget;
      if (nsForm)
      {
         if (ContainsText(nsForm.action, 'javascript:'))
         {
            return;
         }
         var bPassword = false;
         for (var j=0; j < nsForm.elements.length; j ++ )
         {
           if (nsForm.elements[j].type == "password") 
           {
             bPassword = true;
             break;
           }
         }                 
         if (!bPassword) 
         {
            return;
         }        
         var Doc = nsForm.ownerDocument;
         if ( ! isValidDocument(Doc))
         {
            return;
         }       
         var Wnd = Doc.defaultView;
         while (Wnd.frameElement || (Wnd != Wnd.parent))
         {
            Wnd = Wnd.parent;
         }
         pdXPCOM.OnPostWebForm(nsForm);
      }
   }
   catch(e)
   {
     if (DEBUG_MODE) 
      window.alert("onSubmit " + e);
   }
}


function pdOnLoad(AEvent)
{
   if (AEvent)
   try
   {
      if (AEvent.originalTarget instanceof HTMLDocument)
      {
         var Doc = AEvent.originalTarget;

         if (!isValidDocument(Doc))
         {
            return false;
         }
        
         var Wnd = Doc.defaultView;
         if ((Wnd.frameElement) || (Wnd != Wnd.parent))
         {
            return false;
         }   
         
         
         var nsForm = null;    
         
         for (var i=0; i < Doc.forms.length; i++ )
         {
           for (var j=0; j < Doc.forms[i].elements.length; j ++ )
           {
             if (Doc.forms[i].elements[j].type == "password") 
             {
               nsForm = Doc.forms[i];
               break;
             }
           }          
         }       
         
       if (nsForm)
       {   

         autoFillDocument = Doc;
         autoFillTimerID = setTimeout('pdAutoFillDocument()', 10);                    
         return true;
       }
         
      }
   }
   catch (e)
   {
     if (DEBUG_MODE) 
      window.alert("onLoad " + e);
   }
}

function pdOnUnload()
{
   try
   {
      gBrowser.removeEventListener('load', pdOnLoad, true);
      window.removeEventListener('submit', pdOnSubmit, true);
      removeEventListener('unload', pdOnUnload, false);
   }
   catch (e)
   {
     if (DEBUG_MODE) 
      window.alert("OnUnload " + e);
   }
   try
   {
      if ('@mozilla.org/preferences;1' in Components.classes)
      {
         if ('nsIPrefService' in Components.interfaces && 'nsIPrefBranch' in Components.interfaces)
         {
            var PrefService = Components.classes['@mozilla.org/preferences;1'].createInstance(Components.interfaces.nsIPref);
            var PrefBranch = PrefService.getBranch('signon.');
            if (PrefBranch != null)
            {
               PrefBranch.setBoolPref('rememberSignons', tmpSignons);
            }
         }
         else
         if ('nsIPref' in Components.interfaces)
         {
            var Pref = Components.classes['@mozilla.org/preferences;1'].createInstance(Components.interfaces.nsIPref);
            Pref.SetBoolPref('signon.rememberSignons', tmpSignons);
         }
      }
   }
   catch (e)
   {
     if (DEBUG_MODE) 
      window.alert("OnUnload " + e);
   }
}

function showPD()
{
   pdXPCOM.CheckLockState();          
//   pdAutoFillDocument();
}
